﻿using Infragistics.Web.UI.GridControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["data"] == null)
            Session["data"] = GetEmployees();

        m_grdManageItems.DataSource = Session["data"];

        InitColumns(m_grdManageItems);
        InitBehaviors(m_grdManageItems);
        InitGrid(m_grdManageItems);
    }

    private void InitGrid(WebDataGrid grid)
    {
        grid.Height = Unit.Pixel(425 - 50);
        grid.Width = Unit.Percentage(100);
    }

    private void InitBehaviors(WebDataGrid grid)
    {
        ColumnResizing resizing = grid.Behaviors.CreateBehavior<ColumnResizing>();
        resizing.Enabled = true;

        Selection selection = grid.Behaviors.CreateBehavior<Selection>();
        selection.CellClickAction = CellClickAction.Row;
        selection.RowSelectType = SelectType.Multiple;

        EditingCore editing = grid.Behaviors.CreateBehavior<EditingCore>();
        editing.Enabled = true;
        RowDeleting deleting = editing.Behaviors.CreateBehavior<RowDeleting>();
        deleting.Enabled = true;
    }

    private void InitColumns(WebDataGrid grid)
    {
        BoundDataField bdf = new BoundDataField();
        bdf.Key = bdf.DataFieldName = bdf.Header.Text = "EmployeeID";
        bdf.Hidden = true;
        grid.Columns.Add(bdf);

        bdf = new BoundDataField();
        bdf.Key = bdf.DataFieldName = bdf.Header.Text = "Name";
        grid.Columns.Add(bdf);

        bdf = new BoundCheckBoxField();
        bdf.Key = bdf.DataFieldName = bdf.Header.Text = "OnSite";
        grid.Columns.Add(bdf);

        bdf = new BoundDataField();
        bdf.Key = bdf.DataFieldName = bdf.Header.Text = "DateOfHire";
        grid.Columns.Add(bdf);

        bdf = new BoundDataField();
        bdf.Key = bdf.DataFieldName = bdf.Header.Text = "Department";
        grid.Columns.Add(bdf);
    }

    private DataTable GetEmployees(int count = 1000)
    {
        DataTable dtData = new DataTable("Employees");

        dtData.Columns.Add("EmployeeID", typeof(int));
        dtData.Columns.Add("Name", typeof(string));
        dtData.Columns.Add("OnSite", typeof(bool));
        dtData.Columns.Add("DateOfHire", typeof(DateTime));
        dtData.Columns.Add("Department", typeof(int));

        for (int i = 0; i < count; i++)
        {
            dtData.Rows.Add(new object[] { i, string.Format("Name {0}", i), (i % 2 == 0), DateTime.Today.Date.AddDays(-1 * i), i % 8 });
        }

        dtData.PrimaryKey = new DataColumn[] { dtData.Columns["EmployeeID"] };

        return dtData;
    }
}